summaryrefslogtreecommitdiff
path: root/flash_lenovobios_stage1
diff options
context:
space:
mode:
Diffstat (limited to 'flash_lenovobios_stage1')
-rwxr-xr-xflash_lenovobios_stage170
1 files changed, 70 insertions, 0 deletions
diff --git a/flash_lenovobios_stage1 b/flash_lenovobios_stage1
new file mode 100755
index 0000000..0a7a575
--- /dev/null
+++ b/flash_lenovobios_stage1
@@ -0,0 +1,70 @@
+#!/bin/bash
+
+# lenovobios_firstflash: flashes libreboot on an X60/T60 while Lenovo BIOS is running
+#
+# Copyright (C) 2014 Francis Rowe <info@gluglug.org.uk>
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+#
+
+set -u -e
+
+# These are the tested platforms
+if [ $(uname -i) = "i686" ] || [ $(uname -m) = "i686" ]; then
+ echo "Running on i686. ok."
+ arch=i686
+ sleep 5
+elif [ $(uname -i) = "x86_64" ] || [ $(uname -m) = "x86_64" ]; then
+ echo "Running on x86_64. ok."
+ arch=x86_64
+ sleep 5
+else
+ echo "This script must be run on an i686 or x86_64 host. x86_64 is recommended."
+ exit 1
+fi
+if [ -f "DEBLOB" ]; then
+ # In a src archive or git
+ arch=.
+fi
+
+if [[ $EUID -ne 0 ]]; then
+ echo "This script must be run as root"
+ exit 1
+fi
+
+if (( $# != 1 )); then
+ echo "usage: $0 path/to/yourrom.rom"
+ echo "You need to specify exactly 1 file"
+ exit 1
+fi
+if [ ! -f "$1" ]; then
+ echo "File not found!"
+ exit 1
+fi
+
+errOut="
+ BUCTS failed. Make sure BUC.TS is 1, or else you will brick your machine.
+ ABORTING so as to protect against bricking the machine.
+"
+
+set -v
+# for T60 or X60 owners with Lenovo BIOS
+# does the 1st part of the flash before shut down
+
+# needed for first flashing, otherwise machine will be bricked
+./bucts/$arch/bucts 1 || { printf '%s' "$errOut"; exit 1; }
+
+# run both. one will fail (and be harmless), the other will succeed.
+./flashrom/$arch/flashrom_lenovobios_sst -p internal -w "$1" || true
+./flashrom/$arch/flashrom_lenovobios_macronix -p internal -w "$1" || true